<template>

<div class="home col-8 mx-auto">
    <h2 class="text-center greeting indent">Subscription payment</h2>

    <div class="card card-primary card-outline">
        <div class="card-body box-profile">
            <ul class="list-group list-group-unbordered mb-3">
                <li class="list-group-item" >
                    <div class="initial-align">
                        <h4>Choose a subscription plan:</h4>
                    </div>
                    <form>
                        <div class="form-group row" v-for="(subscription_term, index) in subscription_terms" :key="index">
                            <div class="col">
                                <input type="radio" name="subscription-plan" :id="'subscription-plan-' + subscription_term.id" :value="subscription_term" v-model="selected_plan" :checked="setCheckedRadio(index)">
                                <label :for="subscription_term.id">{{ subscription_term.months }} {{ getWordMonth(subscription_term.months) }}, monthly price: {{ subscription_term.monthly_price }} UAH, total price: {{ subscription_term.total_price }} UAH </label>
                            </div>
                        </div>
                    </form>
                </li>
                <li class="list-group-item" id="choose-payment-method">
                    <div class="initial-align">
                        <h4>Choose an existing payment method or <a href="#create-new-payment">create new</a>:</h4>
                    </div>
                    <div class="form-group row">
                        <div class="col initial-align">
                            <div v-show="payment_methods_load_status == 2
                                && payment_methods.length == 0"
                                class="">
                                    No payment method on file, please add a payment method.
                            </div>
                            <div v-show="payment_methods_load_status == 2
                                    && payment_methods.length > 0">
                                <form>
                                    <div v-for="(method, key) in payment_methods" :key="'method-'+key" class="form-group row">
                                        <div class="col-1">
                                            <input type="radio" name="payment-method" :id="'payment-method' + method.id" :value="method" v-model="selected_payment_method" :checked="setSelectedMethod(key)">
                                        </div>
                                        <div class="col-2">
                                            {{ method.brand.charAt(0).toUpperCase() }}{{ method.brand.slice(1) }}
                                        </div>
                                        <div class="col-6">
                                            Ending In: {{ method.last_four }} Exp: {{ method.exp_month }} / {{ method.exp_year }}
                                        </div>
                                        <div class="col-2">
                                            <a href="#" @click.prevent="removePaymentMethod( method.id )">Remove</a>
                                        </div>
                                    </div>
                                </form>

                            </div>
                        </div>
                    </div>
                </li>
                <li class="list-group-item" id="create-new-payment">
                    <div class="initial-align">
                        <h4>Create new payment method:</h4>
                    </div>
                    <div class="form-group row">
                        <div class="col">
                            <label>Card Holder Name</label>
                            <input id="card-holder-name" type="text" v-model="name" class="form-control mb-2">
                            <label>Enter your card data</label>
                            <div id="card-element">

                            </div>
                            <div class="text-center">
                                <button class="btn btn-primary mt-3" id="add-card-button" v-on:click="submitPaymentMethod()">
                                    Create
                                </button>
                            </div>
                        </div>
                    </div>
                </li>
            </ul>
        </div>
        <div v-show="subscription_plan_not_choosen" class="text-center">
            <div class="alert alert-danger" role="alert">
                Please choose the subscription plan
            </div>
        </div>
        <div v-show="payment_method_not_choosen" class="text-center">
            <div class="alert alert-danger" role="alert">
                Please choose the payment method
            </div>
        </div>

        <div class="text-center">
            <button class="btn btn-primary mb-3" id="subscribe" v-on:click="updateSubscription()">
                Subscribe
            </button>
        </div>
    </div>
</div>

</template>

<script src="https://js.stripe.com/v3/"></script>

<script>
import Subscription from "../src/apis/Subscription";
import User from "../src/apis/User";

export default {
    props: ['user'],
    data() {
        return {
            subscription_terms: null,
            selected_plan: {},
            checked_value: 0,
            intent: {},
            stripe_public_key: '',
            stripe: '',
            elements: '',
            card: '',
            name: '',
            payment_status: 0,
            payment_status_error: '',
            payment_methods: [],
            payment_methods_load_status: 0,
            selected_payment_method: {},
            subscription_plan_not_choosen: false,
            payment_method_not_choosen: false,
        }
    },
    watch: {
        /*selected_plan: {
            handler: 'getPaymentData'
        }*/
    },
    mounted() {
		this.checked_value = 1;
        this.getSubscriptionTerms();
        this.loadPaymentMethods();

        //this.setStripe();
        //this.stripe = this.loadStripe();
    },
    methods: {
        getSubscriptionTerms() {
            Subscription.getSubscriptionTerms().then(response => {
                this.subscription_terms = response.data.subscription_terms;
                this.stripe_public_key = response.data.stripe_public_key;
                this.intent = response.data.intent;

                this.includeStripe('js.stripe.com/v3/', function(){
                    this.configureStripe();
                }.bind(this) );
            })
        },
        getWordMonth(months) {
            if (months > 1) {
                return 'months';
            }
            return 'month';
        },
        getPaymentData() {
            console.log(this.selected_plan);
        },
        setCheckedRadio(index) {
            let result;
            if (index == 0) {
                result = true;
            } else {
                result = false;
            }
            //console.log(result);
            return result;
        },
        setSelectedMethod(key) {
            let result;
            if( key == 0) {
                result = true;
            } else {
                result = false;
            }
            //console.log(result);
            return result;
        },
        includeStripe( URL, callback ){
            let documentTag = document, tag = 'script',
                object = documentTag.createElement(tag),
                scriptTag = documentTag.getElementsByTagName(tag)[0];
            object.src = '//' + URL;
            if (callback) {
                object.addEventListener('load', function (e) {
                    callback(null, e);
                }, false);
            }
            scriptTag.parentNode.insertBefore(object, scriptTag);
        },
        configureStripe(){
            this.stripe = Stripe( this.stripe_public_key );

            this.elements = this.stripe.elements();
            this.card = this.elements.create('card');

            this.card.mount('#card-element');
        },
        submitPaymentMethod(){
            this.payment_status = 1;

            this.stripe.confirmCardSetup(
                this.intent.client_secret, {
                    payment_method: {
                        card: this.card,
                        billing_details: {
                            name: this.name
                        }
                    }
                }
            ).then(function(result) {
                if (result.error) {
                    this.payment_status = 3;
                    this.payment_status_error = result.error.message;
                } else {
                    this.savePaymentMethod( result.setupIntent.payment_method );
                    this.payment_status = 2;
                    this.card.clear();
                    this.name = '';
                }
            }.bind(this));
        },
        savePaymentMethod( method ){
            Subscription.savePaymentMethod(method)
            .then( function(){
                this.loadPaymentMethods();
            }
            .bind(this));
        },
        loadPaymentMethods(){
            this.payment_methods_load_status = 1;

            Subscription.getPaymentMethods()
            .then( function( response ){
                this.payment_methods = response.data;

                this.payment_methods_load_status = 2;
            }
            .bind(this));
        },
        removePaymentMethod( paymentID ){
            Subscription.removePaymentMethod(paymentID).
            then( function( response ){
                this.loadPaymentMethods();
            }.bind(this));
        },
        updateSubscription(){
            this.subscription_plan_not_choosen = false;
            this.payment_method_not_choosen = false;

            if (!this.selected_plan.stripe_id) {
                this.subscription_plan_not_choosen = true;
                return;
            }
            if (!this.selected_payment_method.id) {
                this.payment_method_not_choosen = true;
                return;
            }
            //console.log(this.selected_plan);
            //console.log(this.selected_payment_method);
            Subscription.updateSubscription(
                this.selected_plan,
                this.selected_payment_method
            ).then( function( response ){
                alert('You Are Subscribed!');
            }.bind(this));
        },
    }
}

</script>

<style scoped>

.card, .card-body, .list-group, .list-group-item {
    background-color: black;
    border-color: orange;
    color: orange;
}

.card {
    border: none;
}

#card-element {
    background-color: antiquewhite;
}

#add-card-button {
    text-align: initial;
}

#select-payment-method {
    vertical-align: -webkit-baseline-middle;
}

.initial-align {
    text-align: initial;
}

</style>
